#include "testdriver.h"

int numtests;

int main(void)
{
	char fail;
	int status;
	long d0, d1, result;
	
	status = 0;
	
	++numtests;
	/* test that ABCD clears Z only if result is nonzero */
	__asm__ __volatile__(
		"\tclr.l %[d0]\n"
		"\tmove.l #1,%[d1]\n"
		"\tabcd %[d0],%[d0]\n"
		"\tseq %[fail]\n"
	: [fail] "=dm"(fail), [d0]"=d"(d0), [d1]"=d"(d1)
	:
	: "cc", "memory");
	CHECK(fail);
	
	++numtests;
	__asm__ __volatile__(
		"\tmove.l #1,%[d1]\n"
		"\tclr.l %[d0]\n"
		"\tabcd %[d1],%[d1]\n"
		"\tseq %[fail]\n"
	: [fail] "=dm"(fail), [d0]"=d"(d0), [d1]"=d"(d1)
	:
	: "cc", "memory");
	CHECK(fail);
	
	++numtests;
	__asm__ __volatile__(
		"\tmove.l #0x033,%[result]\n"
		"\tmove.l #0x044,%[d0]\n"
		"\tabcd %[d0],%[result]\n"
	: [result]"=d"(result), [d0]"=d"(d0)
	:
	: "cc", "memory");
	EXPECT(result, 0x77L);
	
	++numtests;
	__asm__ __volatile__(
		"\tmove.l #0x155,%[result]\n"
		"\tabcd %[result],%[result]\n"
	: [result]"=d"(result)
	:
	: "cc", "memory");
	EXPECT(result, 0x110L);
	
	return status;
}
