#include "testdriver.h"

int numtests;

int main(void)
{
	char fail, fail2;
	int status;
	long d0, result;
	
	status = 0;
	
	++numtests;
	__asm__ __volatile__(
		"\tsub.l %[d0],%[d0]\n"
		"\tsne %[fail]\n"
	: [fail]"=dm"(fail), [d0]"=d"(d0)
	:
	: "cc", "memory");
	CHECK(fail);
	
	++numtests;
	__asm__ __volatile__(
		"\tmove.b #0x80,%[d0]\n"
		"\tadd.b %[d0],%[d0]\n"
		"\tsne %[fail]\n"
	: [fail]"=dm"(fail), [d0]"=d"(d0)
	:
	: "cc", "memory");
	CHECK(fail);
	
	++numtests;
	__asm__ __volatile__(
		"\tmove.w #0x8000,%[d0]\n"
		"\tadd.w %[d0],%[d0]\n"
		"\tsne %[fail]\n"
	: [fail]"=dm"(fail), [d0]"=d"(d0)
	:
	: "cc", "memory");
	CHECK(fail);
	
	++numtests;
	__asm__ __volatile__(
		"\tmove.l #0x80000000,%[d0]\n"
		"\tadd.l %[d0],%[d0]\n"
		"\tsne %[fail]\n"
	: [fail]"=dm"(fail), [d0]"=d"(d0)
	:
	: "cc", "memory");
	CHECK(fail);
	
	++numtests;
	__asm__ __volatile__(
		"\tmove.l #0x55667778,%[result]\n"
		"\tmove.l #0x11223388,%[d0]\n"
		"\tadd.b %[d0],%[result]\n"
		"\tsne %[fail]\n"
		"\tscc %[fail2]\n"
	: [result]"=d"(result), [fail]"=dm"(fail), [fail2]"=dm"(fail2), [d0]"=d"(d0)
	:
	: "cc", "memory");
	CHECK(fail);
	CHECK(fail2);
	EXPECT(result, 0x55667700L);
	
	++numtests;
	__asm__ __volatile__(
		"\tmove.l #0x55667788,%[result]\n"
		"\tmove.l #0x11223344,%[d0]\n"
		"\tadd.w %[d0],%[result]\n"
		"\tscs %[fail]\n"
	: [result]"=d"(result), [fail]"=dm"(fail), [d0]"=d"(d0)
	:
	: "cc", "memory");
	CHECK(fail);
	EXPECT(result, 0x5566aaccL);
	
	++numtests;
	__asm__ __volatile__(
		"\tmove.l #0x55667788,%[result]\n"
		"\tmove.l #0x11223344,%[d0]\n"
		"\tadd.l %[d0],%[result]\n"
		"\tscs %[fail]\n"
	: [result]"=d"(result), [fail]"=dm"(fail), [d0]"=d"(d0)
	:
	: "cc", "memory");
	CHECK(fail);
	EXPECT(result, 0x6688aaccL);
	
	++numtests;
	__asm__ __volatile__(
		"\tmove.l #0x80000000,%[result]\n"
		"\tadd.l %[result],%[result]\n"
		"\tscc %[fail]\n"
		"\tsvc %[fail2]\n"
	: [result]"=d"(result), [fail]"=dm"(fail), [fail2]"=dm"(fail2)
	:
	: "cc", "memory");
	CHECK(fail);
	CHECK(fail2);
	EXPECT(result, 0L);
	
	return status;
}
