#include "testdriver.h"

int numtests;

int main(void)
{
	char fail;
	int status;
	long a0;
	long d0;
	
	status = 0;
	
	/* test that ADDA does not modify CCR */
	++numtests;
	__asm__ __volatile__(
		"\tsuba.l %[a0],%[a0]\n"
		"\tmove #0,ccr\n"
		"\tadda.l %[a0],%[a0]\n"
		"\tseq %[fail]\n"
	: [fail]"=dm"(fail), [a0]"=a"(a0)
	:
	: "cc", "memory");
	CHECK(fail);
	
	++numtests;
	__asm__ __volatile__(
		"\tmove.l #0x80000000,%[a0]\n"
		"\tmove #0,ccr\n"
		"\tadda.l %[a0],%[a0]\n"
		"\tscs %[fail]\n"
	: [fail]"=dm"(fail), [a0]"=a"(a0)
	:
	: "cc", "memory");
	CHECK(fail);
	
	++numtests;
	__asm__ __volatile__(
		"\tmove.l #0x80000000,%[a0]\n"
		"\tmove #0,ccr\n"
		"\tadda.l %[a0],%[a0]\n"
		"\tsvs %[fail]\n"
	: [fail]"=dm"(fail), [a0]"=a"(a0)
	:
	: "cc", "memory");
	CHECK(fail);
	
	++numtests;
	__asm__ __volatile__(
		"\tmove.l #0x40000000,%[a0]\n"
		"\tmove #0,ccr\n"
		"\tadda.l %[a0],%[a0]\n"
		"\tsmi %[fail]\n"
	: [fail]"=dm"(fail), [a0]"=a"(a0)
	:
	: "cc", "memory");
	CHECK(fail);
	
	++numtests;
	__asm__ __volatile__(
		"\tmove.l #0x80000000,%[a0]\n"
		"\tclr.l %[d0]\n"
		"\tmove #0,ccr\n"
		"\tadda.l %[a0],%[a0]\n"
#if defined(__mc68010__) || defined(__mc68020__) || defined(__mc68030__) || defined(__mc68040__) || defined(__mc68060__)
		"\tmove ccr,%[d0]\n"
#else
		"\tmove sr,%[d0]\n"
#endif
		"\ttst.b %[d0]\n"
		"\tsne %[fail]\n"
	: [fail]"=dm"(fail), [a0]"=a"(a0), [d0]"=d"(d0)
	:
	: "cc", "memory");
	CHECK(fail);
	
	return status;
}
