#include "testdriver.h"

int numtests;

int main(void)
{
	char fail, fail2;
	int status;
	long d0, result;
	
	status = 0;
	
	++numtests;
	__asm__ __volatile__(
		"\tsub.l %[d0],%[d0]\n"
		"\tsne %[fail]\n"
	: [fail]"=dm"(fail), [d0]"=d"(d0)
	:
	: "cc", "memory");
	CHECK(fail);
	
	++numtests;
	__asm__ __volatile__(
		"\tsub.l %[d0],%[d0]\n"
		"\taddi.b #0,%[d0]\n"
		"\tsne %[fail]\n"
	: [fail]"=dm"(fail), [d0]"=d"(d0)
	:
	: "cc", "memory");
	CHECK(fail);
	
	++numtests;
	__asm__ __volatile__(
		"\tsub.l %[d0],%[d0]\n"
		"\taddi.w #0,%[d0]\n"
		"\tsne %[fail]\n"
	: [fail]"=dm"(fail), [d0]"=d"(d0)
	:
	: "cc", "memory");
	CHECK(fail);
	
	++numtests;
	__asm__ __volatile__(
		"\tsub.l %[d0],%[d0]\n"
		"\taddi.l #0,%[d0]\n"
		"\tsne %[fail]\n"
	: [fail]"=dm"(fail), [d0]"=d"(d0)
	:
	: "cc", "memory");
	CHECK(fail);
	
	++numtests;
	__asm__ __volatile__(
		"\tmove.l #0x55667778,%[result]\n"
		"\taddi.b #0x88,%[result]\n"
		"\tsne %[fail]\n"
		"\tscc %[fail2]\n"
	: [fail]"=dm"(fail), [fail2]"=dm"(fail2), [result]"=d"(result)
	:
	: "cc", "memory");
	CHECK(fail);
	CHECK(fail2);
	EXPECT(result, 0x55667700L);
	
	++numtests;
	__asm__ __volatile__(
		"\tmove.l #0x55667788,%[result]\n"
		"\taddi.w #0x3344,%[result]\n"
		"\tscs %[fail]\n"
	: [fail]"=dm"(fail), [result]"=d"(result)
	:
	: "cc", "memory");
	CHECK(fail);
	EXPECT(result, 0x5566aaccL);
	
	++numtests;
	__asm__ __volatile__(
		"\tmove.l #0x55667788,%[result]\n"
		"\taddi.l #0x11223344,%[result]\n"
	: [result]"=d"(result)
	:
	: "cc", "memory");
	EXPECT(result, 0x6688aaccL);
	
	return status;
}
