#include "testdriver.h"

int numtests;

int main(void)
{
	int status;
	char fail;
	long d0, result;
	long data[2];
	
	status = 0;
	
	++numtests;
	__asm__ __volatile__(
		"\tmove.l #-1,%[result]\n"
		"\tmove.l %[result],%[d0]\n"
		"\tbfextu %[d0]{1:3},%[result]\n"
		"\tspl %[fail]\n"
	: [result]"=d"(result), [fail]"=dm"(fail), [d0]"=d"(d0)
	:
	: "cc", "memory");
	CHECK(fail);
	EXPECT(result, 0x7L);
	
	++numtests;
	__asm__ __volatile__(
		"\tmove.l #-1,%[result]\n"
		"\tmove.l %[result],%[d0]\n"
		"\tbfexts %[d0]{1:3},%[result]\n"
		"\tspl %[fail]\n"
	: [result]"=d"(result), [fail]"=dm"(fail), [d0]"=d"(d0)
	:
	: "cc", "memory");
	CHECK(fail);
	EXPECT(result, -1L);
	
	++numtests;
	__asm__ __volatile__(
		"\tmove.l #0xf0f0f0f0,%[d0]\n"
		"\tbfextu %[d0]{2:3},%[result]\n"
	: [result]"=d"(result), [d0]"=d"(d0)
	:
	: "cc", "memory");
	EXPECT(result, 0x06L);
	
	++numtests;
	__asm__ __volatile__(
		"\tmove.l #0xf0f0f0f0,%[d0]\n"
		"\tbfextu %[d0]{7:3},%[result]\n"
		"\tsmi %[fail]\n"
	: [result]"=d"(result), [fail]"=dm"(fail), [d0]"=d"(d0)
	:
	: "cc", "memory");
	CHECK(fail);
	EXPECT(result, 0x03L);
	
	++numtests;
	__asm__ __volatile__(
		"\tmove.l #0xf0f0f0f0,%[d0]\n"
		"\tbfexts %[d0]{2:3},%[result]\n"
	: [result]"=d"(result), [d0]"=d"(d0)
	:
	: "cc", "memory");
	EXPECT(result, 0xfffffffeL);
	
	++numtests;
	__asm__ __volatile__(
		"\tmove.l #0xf0f0f0f0,%[d0]\n"
		"\tbfexts %[d0]{7:3},%[result]\n"
		"\tsmi %[fail]\n"
	: [result]"=d"(result), [fail]"=dm"(fail), [d0]"=d"(d0)
	:
	: "cc", "memory");
	CHECK(fail);
	EXPECT(result, 0x03L);
	
	++numtests;
	__asm__ __volatile__(
		"\tmove.l #0xf0f0f0f0,%[d0]\n"
		"\tbfextu %[d0]{31:31},%[result]\n"
	: [result]"=d"(result), [d0]"=d"(d0)
	:
	: "cc", "memory");
	EXPECT(result, 0x3c3c3c3cL);
	
	++numtests;
	__asm__ __volatile__(
		"\tmove.l #0xf0f0f0f0,%[d0]\n"
		"\tbfextu %[d0]{24:9},%[result]\n"
	: [result]"=d"(result), [d0]"=d"(d0)
	:
	: "cc", "memory");
	EXPECT(result, 0x1e1L);
	
	++numtests;
	__asm__ __volatile__(
		"\tmove.l #0x1e1,%[result]\n"
		"\tbfclr %[result]{24:1}\n"
	: [result]"=d"(result)
	:
	: "cc", "memory");
	EXPECT(result, 0x161L);
	
	++numtests;
	__asm__ __volatile__(
		"\tmove.l #0x161,%[result]\n"
		"\tbfset %[result]{24:5}\n"
	: [result]"=d"(result)
	:
	: "cc", "memory");
	EXPECT(result, 0x1f9L);
	
	++numtests;
	__asm__ __volatile__(
		"\tmove.l #0x1f9,%[result]\n"
		"\tbfchg %[result]{27:3}\n"
	: [result]"=d"(result)
	:
	: "cc", "memory");
	EXPECT(result, 0x1e5L);
	
	++numtests;
	__asm__ __volatile__(
		"\tmove.l #-1,%[d0]\n"
		"\tmove.l %[d0],(%[a0])\n"
		"\tmove.l %[d0],%[result]\n"
		"\tbfextu (%[a0]){1:3},%[result]\n"
		"\tspl %[fail]\n"
	: [result]"=d"(result), [fail]"=dm"(fail), [d0]"=d"(d0)
	: [a0]"a"(data)
	: "cc", "memory");
	CHECK(fail);
	EXPECT(result, 0x7L);
	
	++numtests;
	__asm__ __volatile__(
		"\tmove.l #-1,%[d0]\n"
		"\tmove.l %[d0],(%[a0])\n"
		"\tmove.l #0,%[result]\n"
		"\tbfexts (%[a0]){1:3},%[result]\n"
		"\tspl %[fail]\n"
	: [result]"=d"(result), [fail]"=dm"(fail), [d0]"=d"(d0)
	: [a0]"a"(data)
	: "cc", "memory");
	CHECK(fail);
	EXPECT(result, -1L);
	
	++numtests;
	__asm__ __volatile__(
		"\tmove.l #0xf0f0f0f0,%[d0]\n"
		"\tmove.l %[d0],(%[a0])\n"
		"\tmove.l #0,%[result]\n"
		"\tbfextu (%[a0]){2:3},%[result]\n"
		"\tspl %[fail]\n"
	: [result]"=d"(result), [fail]"=dm"(fail), [d0]"=d"(d0)
	: [a0]"a"(data)
	: "cc", "memory");
	CHECK(fail);
	EXPECT(result, 6L);
	
	++numtests;
	__asm__ __volatile__(
		"\tmove.l #0xf0f0f0f0,%[d0]\n"
		"\tmove.l %[d0],(%[a0])\n"
		"\tmove.l #0,%[result]\n"
		"\tbfexts (%[a0]){2:3},%[result]\n"
		"\tspl %[fail]\n"
	: [result]"=d"(result), [fail]"=dm"(fail), [d0]"=d"(d0)
	: [a0]"a"(data)
	: "cc", "memory");
	CHECK(fail);
	EXPECT(result, 0xfffffffeL);
	
	++numtests;
	__asm__ __volatile__(
		"\tmove.l #0xf0f0f0f0,%[d0]\n"
		"\tmove.l %[d0],(%[a0])\n"
		"\tmove.l %[d0],4(%[a0])\n"
		"\tmove.l #0,%[result]\n"
		"\tbfextu (%[a0]){24:9},%[result]\n"
		"\tspl %[fail]\n"
	: [result]"=d"(result), [fail]"=dm"(fail), [d0]"=d"(d0)
	: [a0]"a"(data)
	: "cc", "memory");
	CHECK(fail);
	EXPECT(result, 0x1e1L);
	
	return status;
}
