#include "testdriver.h"

int numtests;

int main(void)
{
	int status;
	long d0, result;
	long data[2];
	
	status = 0;
	
	++numtests;
	__asm__ __volatile__(
		"\tmove.l #-1,%[result]\n"
		"\tmove.l #1,%[d0]\n"
		"\tbfins %[d0],%[result]{4:4}\n"
	: [result]"=d"(result), [d0]"=d"(d0)
	:
	: "cc", "memory");
	EXPECT(result, 0xf1ffffffL);
	
	++numtests;
	__asm__ __volatile__(
		"\tmove.l #0xf1ffffff,%[result]\n"
		"\tmove.l #3,%[d0]\n"
		"\tbfins %[d0],%[result]{5:2}\n"
	: [result]"=d"(result), [d0]"=d"(d0)
	:
	: "cc", "memory");
	EXPECT(result, 0xf7ffffffL);
	
	++numtests;
	__asm__ __volatile__(
		"\tmove.l #0xf7ffffff,%[result]\n"
		"\tmove.l #0,%[d0]\n"
		"\tbfins %[d0],%[result]{8:16}\n"
	: [result]"=d"(result), [d0]"=d"(d0)
	:
	: "cc", "memory");
	EXPECT(result, 0xf70000ffL);
	
	++numtests;
	__asm__ __volatile__(
		"\tmove.l #1,%[d0]\n"
		"\tmove.l #-1,(%[a0])\n"
		"\tbfins %[d0],(%[a0]){4:4}\n"
	: [d0]"=d"(d0)
	: [a0]"a"(data)
	: "cc", "memory");
	EXPECT(data[0], 0xf1ffffffL);
	
	++numtests;
	data[0] = 0xf1ffffffL;
	__asm__ __volatile__(
		"\tmove.l #3,%[d0]\n"
		"\tbfins %[d0],(%[a0]){5:2}\n"
	: [d0]"=d"(d0)
	: [a0]"a"(data)
	: "cc", "memory");
	EXPECT(data[0], 0xf7ffffffL);
	
	++numtests;
	data[0] = 0xf7ffffffL;
	__asm__ __volatile__(
		"\tmove.l #0,%[d0]\n"
		"\tbfins %[d0],(%[a0]){8:16}\n"
	: [d0]"=d"(d0)
	: [a0]"a"(data)
	: "cc", "memory");
	EXPECT(data[0], 0xf70000ffL);
	
	++numtests;
	data[0] = 0xf70000ffL;
	data[1] = -1L;
	__asm__ __volatile__(
		"\tmove.l #0,%[d0]\n"
		"\tbfins %[d0],(%[a0]){31:2}\n"
	: [d0]"=d"(d0)
	: [a0]"a"(data)
	: "cc", "memory");
	EXPECT(data[0], 0xf70000feL);
	EXPECT(data[1], 0x7fffffffL);
	
	return status;
}
