/*
 * Test:USES_FPU
 */
#include "testdriver.h"

#ifndef __HAVE_68881__
 #error "must be compiled with FPU support"
#endif

int numtests;


int main(void)
{
	int status;
	union ld_union fp0;
	union ld_union fp1;
	long d0;
	
	status = 0;
	
	++numtests;
	__asm__ __volatile__(
		"\tfmove.l #4096,%[fp0]\n"
		"\tfgetexp.x %[fp0],%[fp1]\n"
		"\tfmove.l %[fp1],%[d0]\n"
	: [fp0]"=f"(fp0.d), [fp1]"=f"(fp1.d), [d0]"=d"(d0)
	:
	: "cc", "memory");
	EXPECT_FP(fp0, 0x400b0000L, 0x80000000L, 0x00000000L);
	EXPECT_FP(fp1, 0x40020000L, 0xc0000000L, 0x00000000L);
	EXPECT(d0, 12L);
	
	return status;
}
