/*
 * Test:USES_FPU
 */
#include "testdriver.h"

#ifndef __HAVE_68881__
 #error "must be compiled with FPU support"
#endif

int numtests;


int main(void)
{
	int status;
	union ld_union fp0;
	union ld_union fp1;
	
	status = 0;
	
	++numtests;
	__asm__ __volatile__(
		"\tfmovecr.x #0x00,%[fp0]\n"
		"\tfmove.b #3,%[fp1]\n"
		"\tfsub.x %[fp1],%[fp0]\n"
	: [fp0]"=f"(fp0.d), [fp1]"=f"(fp1.d)
	:
	: "cc", "memory");
	EXPECT_FP(fp0, 0x3ffc0000L, 0x90fdaa22L, 0x168c2350L);
	EXPECT_FP(fp1, 0x40000000L, 0xc0000000L, 0x00000000L);
	
	return status;
}
