/*
 * Test:USES_FPU
 */
#include "testdriver.h"

#ifndef __HAVE_68881__
 #error "must be compiled with FPU support"
#endif

int numtests;

/*
 * 2^16381, should
 */
union ld_union inf_div_4 = { { 0x7ffd0000, 0x80000000, 0x0 } };
union ld_union inf_div_2 = { { 0x7ffe0000, 0x80000000, 0x0 } };


int main(void)
{
	char fail;
	int status;
	union ld_union fp0, fp1;
	
	status = 0;
	
	++numtests;
	__asm__ __volatile__(
		"\tfadd.x %[fp0],%[fp1]\n"
		"\tfmul.l #2,%[fp0]\n"
		"\tfcmp.x %[fp0],%[fp1]\n"
		"\tfsne %[fail]\n"
	: [fail]"=dm"(fail), [fp0]"=f"(fp0.d), [fp1]"=f"(fp1.d)
	: "1"(inf_div_4.d), "2"(inf_div_4.d)
	: "cc", "memory");
	CHECK(fail);
	
	EXPECT_FP(fp0, 0x7ffe0000L, 0x80000000L, 0x0L);
	EXPECT_FP(fp1, 0x7ffe0000L, 0x80000000L, 0x0L);
	
	++numtests;
	__asm__ __volatile__(
		"\tfadd.x %[fp0],%[fp1]\n"
		"\tfmul.l #2,%[fp0]\n"
		"\tfcmp.x %[fp0],%[fp1]\n"
		"\tfsne %[fail]\n"
	: [fail]"=dm"(fail), [fp0]"=f"(fp0.d), [fp1]"=f"(fp1.d)
	: "1"(inf_div_2.d), "2"(inf_div_2.d)
	: "cc", "memory");
	CHECK(fail);
	
	EXPECT_FP(fp0, 0x7fff0000L, 0x0L, 0x0L);
	EXPECT_FP(fp1, 0x7fff0000L, 0x0L, 0x0L);

	return status;
}
